#!/usr/bin/perl
############################################################################
# Created 26/02/2007  by Zulu (MikeD)
# business_intelligence@hotmail.com
#
# Language: http://www.activestate.com/Products/ActivePerl/ 
# IDE:      http://www.activestate.com/products/komodo_ide/
#  
###################################################################################
#
# SOURCE FILE NAME: XiServiceMonitor.pl
#
# DESCRIPTION:      Accept input file name and extension
#                   Read text file of server and services    
#
# INPUT FILE:       XiServiceList.txt
# OUTPUT FILE:      XiServiceMonitor.log
#
# MS cmnd to produce a list of all services:- sc \\hostname query >> c:\serverout.out
#
#####################################################################################
use strict;
use Win32;
use Win32::OLE;

my ($hostname, $servicename, $entry, $XIsPath, $s, $count, $xistatus,
    $restart_status, $loop, @months, @weekDays, $second, $minute, $hour,
    $dayOfMonth, $month, $yearOffset, $dayOfWeek, $dayOfYear, $daylightSavings,
    $theTime, $year);
my (%status, @array);
%status =   (
            1 => 'STOPPED',
            2 => 'START_PENDING',
            3 => 'STOP_PENDING', 
            4 => 'RUNNING',
            5 => 'CONTINUE_PENDING',
            6 => 'PAUSE_PENDING',
            7 => 'PAUSED', 
            8 => 'ERROR'
            );
#
@months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
@weekDays = qw(Sun Mon Tue Wed Thu Fri Sat Sun);
($second, $minute, $hour, $dayOfMonth, $month, $yearOffset, $dayOfWeek, $dayOfYear, $daylightSavings) = localtime();
$year = 1900 + $yearOffset;
$theTime = "$hour:$minute:$second, $weekDays[$dayOfWeek] $months[$month] $dayOfMonth, $year";
#
my $filename = 'XiServiceList.txt';
sub buildarray()                                   #array subroutine
{

#  text file read and loaded on startup
#open (MYFILE, '>>XiPerlService.txt');              #open for write, overwrite
#print MYFILE $theTime, " Start of perl module\n";
open( FILE, "< $filename" ) or die "Can't open $filename : $!";

while( <FILE> ) 
    {
            my $line = $_;
            chomp $line;
            push @array, ($line);
    } 
#close FILE;                             
#
my $loop = 1;
while ($loop eq 1)                      #infinite loop if setting this up to run continually i.e. service 
{                                       #part of - infinite loop 
my $count = 0;
my $entry;
foreach $entry (@array)                  #loops through entire loaded array 
{
            open (MYFILE, '>>XiServiceMonitor.txt');              #open for write, overwrite
            if (($count == 0))           #test 1st entry for host address  
            {   $hostname = "$entry";
                $count = $count + 1;
            }
	    else
            {	$servicename = "$entry";
		sleep(2);	
		&CheckServiceStatus($hostname,$servicename);
		$count = $count + 1;
		sleep(2);
            }
            close FILE;                 
}
}
sleep(300);                             #part of - infinite loop                   

}                                       #part of - infinite loop 
close MYFILE;
#
sub CheckServiceStatus()                # check service sub routine
{
$XIsPath = "WinNT://$hostname/$servicename,service";
$s = Win32::OLE->GetObject($XIsPath)
or print MYFILE $theTime, " Unable to retrieve the object for $XIsPath\n";
sleep(1);
$s->Status();
$xistatus = $status{$s->{status}};
if ($xistatus eq 'STOPPED') 
{
            print MYFILE $theTime, " Restarting: ", $hostname, " ", $servicename, " ", $xistatus, "\n";
	    $s->Start();
            sleep(2);
            $s->Status();
            $restart_status = $status{$s->{status}};
           if ($restart_status eq 'STOPPED')
#            if ($restart_status eq 'RUNNING')             # used to test stop sub routine, as the services tend to always restart
            {
                print MYFILE $theTime, " Stopping All Services: FAILOVER!!", $hostname, "\n";
	    	&StopAllServices($hostname,$servicename);  # run subroutine to shutdown all services for failover
		last;                                      # exit loop
                my $loop = 0;                              #end loop due to restart
	    }; 
};
sleep(2);
}
	
#  Note - it would be cleaner to disable them 1st via the CMC 
#       i.e. stop new requests and allow those running to complete but I don't have that code - yet.
#          
sub StopAllServices()                  # stop all services sub routine
{
my $count = 0;
foreach $entry (@array)                #loops through entire loaded array 
{
if (($count == 0))                     #test 1st entry for host address  
            {   $hostname = "$entry";
                $count = $count + 1;
            }
	    else
            {	$servicename = "$entry";
		$XIsPath = "WinNT://$hostname/$servicename,service";
		$s = Win32::OLE->GetObject($XIsPath)
		or print MYFILE $theTime, " Unable to retrieve the object for $XIsPath\n";
                print MYFILE $theTime, " Stopping Service: ", $servicename, "\n";
		sleep(2);
		$s->Stop();
		$count = $count + 1;
		sleep(2);
            }		
}
}
sub main()
{
buildarray();                              #run array subroutine 
}
main();
